aring the screen the value will be one of \"Screen\", \"Window\", or \"Application\", or undefined if not screen sharing."
          },
          "camera": {
            "type": "boolean",
            "description": "True if the tab is using the camera."
          },
          "microphone": {
            "type": "boolean",
            "description": "True if the tab is using the microphone."
          }
        }
      },
      {
        "id": "Tab",
        "type": "object",
        "properties": {
          "id": {
            "type": "integer",
            "minimum": -1,
            "optional": true,
            "description": "The ID of the tab. Tab IDs are unique within a browser session. Under some circumstances a Tab may not be assigned an ID, for example when querying foreign tabs using the $(ref:sessions) API, in which case a session ID may be present. Tab ID can also be set to $(ref:tabs.TAB_ID_NONE) for apps and devtools windows."
          },
          "index": {
            "type": "integer",
            "minimum": -1,
            "description": "The zero-based index of the tab within its window."
          },
          "windowId": {
            "type": "integer",
            "optional": true,
            "minimum": 0,
            "description": "The ID of the window the tab is contained within."
          },
          "openerTabId": {
            "type": "integer",
            "minimum": -1,
            "optional": true,
            "description": "The ID of the tab that opened this tab, if any. This property is only present if the opener tab still exists."
          },
          "highlighted": {
            "type": "boolean",
            "description": "Whether the tab is highlighted. Works as an alias of active"
          },
          "active": {
            "type": "boolean",
            "description": "Whether the tab is active in its window. (Does not necessarily mean the window is focused.)"
          },
          "pinned": {
            "type": "boolean",
            "description": "Whether the tab is pinned."
          },
          "lastAccessed": {
            "type": "integer",
            "optional": true,
            "description": "The last time the tab was accessed as the number of milliseconds since epoch."
          },
          "audible": {
            "type": "boolean",
            "optional": true,
            "description": "Whether the tab has produced sound over the past couple of seconds (but it might not be heard if also muted). Equivalent to whether the speaker audio indicator is showing."
          },
          "autoDiscardable": {
            "type": "boolean",
            "optional": true,
            "description": "Whether the tab can be discarded automatically by the browser when resources are low."
          },
          "mutedInfo": {
            "$ref": "MutedInfo",
            "optional": true,
            "description": "Current tab muted state and the reason for the last state change."
          },
          "url": {
            "type": "string",
            "optional": true,
            "permissions": ["tabs"],
            "description": "The URL the tab is displaying. This property is only present if the extension's manifest includes the <code>\"tabs\"</code> permission."
          },
          "title": {
            "type": "string",
            "optional": true,
            "permissions": ["tabs"],
            "description": "The title of the tab. This property is only present if the extension's manifest includes the <code>\"tabs\"</code> permission."
          },
          "favIconUrl": {
            "type": "string",
            "optional": true,
            "permissions": ["tabs"],
            "description": "The URL of the tab's favicon. This property is only present if the extension's manifest includes the <code>\"tabs\"</code> permission. It may also be an empty string if the tab is loading."
          },
          "status": {
            "type": "string",
            "optional": true,
            "description": "Either <em>loading</em> or <em>complete</em>."
          },
          "discarded": {
            "type": "boolean",
            "optional": true,
            "description": "True while the tab is not loaded with content."
          },
          "incognito": {
            "type": "boolean",
            "description": "Whether the tab is in an incognito window."
          },
          "width": {
            "type": "integer",
            "optional": true,
            "description": "The width of the tab in pixels."
          },
          "height": {
            "type": "integer",
            "optional": true,
            "description": "The height of the tab in pixels."
          },
          "hidden": {
            "type": "boolean",
            "optional": true,
            "description": "True if the tab is hidden."
          },
          "sessionId": {
            "type": "string",
            "optional": true,
            "description": "The session ID used to uniquely identify a Tab obtained from the $(ref:sessions) API."
          },
          "cookieStoreId": {
            "type": "string",
            "optional": true,
            "description": "The CookieStoreId used for the tab."
          },
          "isArticle": {
            "type": "boolean",
            "optional": true,
            "description": "Whether the document in the tab can be rendered in reader mode."
          },
          "isInReaderMode": {
            "type": "boolean",
            "optional": true,
            "description": "Whether the document in the tab is being rendered in reader mode."
          },
          "sharingState": {
            "$ref": "SharingState",
            "optional": true,
            "description": "Current tab sharing state for screen, microphone and camera."
          },
          "attention": {
            "type": "boolean",
            "optional": true,
            "description": "Whether the tab is drawing attention."
          },
          "successorTabId": {
            "type": "integer",
            "optional": true,
            "minimum": -1,
            "description": "The ID of this tab's successor, if any; $(ref:tabs.TAB_ID_NONE) otherwise."
          },
          "groupId": {
            "type": "integer",
            "optional": true,
            "minimum": -1,
            "description": "The ID of the group that the tab belongs to. $(ref:tabGroups.TAB_GROUP_ID_NONE) (-1) if the tab does not belong to a tab group."
          }
        }
      },
      {
        "id": "ZoomSettingsMode",
        "type": "string",
        "description": "Defines how zoom changes are handled, i.e. which entity is responsible for the actual scaling of the page; defaults to <code>automatic</code>.",
        "enum": [
          {
            "name": "automatic",
            "description": "Zoom changes are handled automatically by the browser."
          },
          {
            "name": "manual",
            "description": "Overrides the automatic handling of zoom changes. The <code>onZoomChange</code> event will still be dispatched, and it is the responsibility of the extension to listen for this event and manually scale the page. This mode does not support <code>per-origin</code> zooming, and will thus ignore the <code>scope</code> zoom setting and assume <code>per-tab</code>."
          },
          {
            "name": "disabled",
            "description": "Disables all zooming in the tab. The tab will revert to the default zoom level, and all attempted zoom changes will be ignored."
          }
        ]
      },
      {
        "id": "ZoomSettingsScope",
        "type": "string",
        "description": "Defines whether zoom changes will persist for the page's origin, or only take effect in this tab; defaults to <code>per-origin</code> when in <code>automatic</code> mode, and <code>per-tab</code> otherwise.",
        "enum": [
          {
            "name": "per-origin",
            "description": "Zoom changes will persist in the zoomed page's origin, i.e. all other tabs navigated to that same origin will be zoomed as well. Moreover, <code>per-origin</code> zoom changes are saved with the origin, meaning that when navigating to other pages in the same origin, they will all be zoomed to the same zoom factor. The <code>per-origin</code> scope is only available in the <code>automatic</code> mode."
          },
          {
            "name": "per-tab",
            "description": "Zoom changes only take effect in this tab, and zoom changes in other tabs will not affect the zooming of this tab. Also, <code>per-tab</code> zoom changes are reset on navigation; navigating a tab will always load pages with their <code>per-origin</code> zoom factors."
          }
        ]
      },
      {
        "id": "ZoomSettings",
        "type": "object",
        "description": "Defines how zoom changes in a tab are handled and at what scope.",
        "properties": {
          "mode": {
            "$ref": "ZoomSettingsMode",
            "description": "Defines how zoom changes are handled, i.e. which entity is responsible for the actual scaling of the page; defaults to <code>automatic</code>.",
            "optional": true
          },
          "scope": {
            "$ref": "ZoomSettingsScope",
            "description": "Defines whether zoom changes will persist for the page's origin, or only take effect in this tab; defaults to <code>per-origin</code> when in <code>automatic</code> mode, and <code>per-tab</code> otherwise.",
            "optional": true
          },
          "defaultZoomFactor": {
            "type": "number",
            "optional": true,
            "description": "Used to return the default zoom level for the current tab in calls to tabs.getZoomSettings."
          }
        }
      },
      {
        "id": "PageSettings",
        "type": "object",
        "description": "Defines the page settings to be used when saving a page as a pdf file.",
        "properties": {
          "toFileName": {
            "type": "string",
            "optional": true,
            "description": "The name of the file. May include optional .pdf extension."
          },
          "paperSizeUnit": {
            "type": "integer",
            "optional": true,
            "description": "The page size unit: 0 = inches, 1 = millimeters. Default: 0."
          },
          "paperWidth": {
            "type": "number",
            "optional": true,
            "description": "The paper width in paper size units. Default: 8.5."
          },
          "paperHeight": {
            "type": "number",
            "optional": true,
            "description": "The paper height in paper size units. Default: 11.0."
          },
          "orientation": {
            "type": "integer",
            "optional": true,
            "description": "The page content orientation: 0 = portrait, 1 = landscape. Default: 0."
          },
          "scaling": {
            "type": "number",
            "optional": true,
            "description": "The page content scaling factor: 1.0 = 100% = normal size. Default: 1.0."
          },
          "shrinkToFit": {
            "type": "boolean",
            "optional": true,
            "description": "Whether the page content should shrink to fit the page width (overrides scaling). Default: true."
          },
          "showBackgroundColors": {
            "type": "boolean",
            "optional": true,
            "description": "Whether the page background colors should be shown. Default: false."
          },
          "showBackgroundImages": {
            "type": "boolean",
            "optional": true,
            "description": "Whether the page background images should be shown. Default: false."
          },
          "edgeLeft": {
            "type": "number",
            "optional": true,
            "description": "The spacing between the left header/footer and the left edge of the paper (inches). Default: 0."
          },
          "edgeRight": {
            "type": "number",
            "optional": true,
            "description": "The spacing between the right header/footer and the right edge of the paper (inches). Default: 0."
          },
          "edgeTop": {
            "type": "number",
            "optional": true,
            "description": "The spacing between the top of the headers and the top edge of the paper (inches). Default: 0"
          },
          "edgeBottom": {
            "type": "number",
            "optional": true,
            "description": "The spacing between the bottom of the footers and the bottom edge of the paper (inches). Default: 0."
          },
          "marginLeft": {
            "type": "number",
            "optional": true,
            "description": "The margin between the page content and the left edge of the paper (inches). Default: 0.5."
          },
          "marginRight": {
            "type": "number",
            "optional": true,
            "description": "The margin between the page content and the right edge of the paper (inches). Default: 0.5."
          },
          "marginTop": {
            "type": "number",
            "optional": true,
            "description": "The margin between the page content and the top edge of the paper (inches). Default: 0.5."
          },
          "marginBottom": {
            "type": "number",
            "optional": true,
            "description": "The margin between the page content and the bottom edge of the paper (inches). Default: 0.5."
          },
          "headerLeft": {
            "type": "string",
            "optional": true,
            "description": "The text for the page's left header. Default: '&T'."
          },
          "headerCenter": {
            "type": "string",
            "optional": true,
            "description": "The text for the page's center header. Default: ''."
          },
          "headerRight": {
            "type": "string",
            "optional": true,
            "description": "The text for the page's right header. Default: '&U'."
          },
          "footerLeft": {
            "type": "string",
            "optional": true,
            "description": "The text for the page's left footer. Default: '&PT'."
          },
          "footerCenter": {
            "type": "string",
            "optional": true,
            "description": "The text for the page's center footer. Default: ''."
          },
          "footerRight": {
            "type": "string",
            "optional": true,
            "description": "The text for the page's right footer. Default: '&D'."
          }
        }
      },
      {
        "id": "TabStatus",
        "type": "string",
        "enum": ["loading", "complete"],
        "description": "Whether the tabs have completed loading."
      },
      {
        "id": "WindowType",
        "type": "string",
        "enum": ["normal", "popup", "panel", "app", "devtools"],
        "description": "The type of window."
      },
      {
        "id": "UpdatePropertyName",
        "type": "string",
        "enum": [
          "attention",
          "audible",
          "autoDiscardable",
          "discarded",
          "favIconUrl",
          "groupId",
          "hidden",
          "isArticle",
          "mutedInfo",
          "pinned",
          "sharingState",
          "status",
          "title",
          "url"
        ],
        "description": "Event names supported in onUpdated."
      },
      {
        "id": "UpdateFilter",
        "type": "object",
        "description": "An object describing filters to apply to tabs.onUpdated events.",
        "properties": {
          "urls": {
            "type": "array",
            "description": "A list of URLs or URL patterns. Events that cannot match any of the URLs will be filtered out.  Filtering with urls requires the <code>\"tabs\"</code> or  <code>\"activeTab\"</code> permission.",
            "optional": true,
            "items": { "type": "string" },
            "minItems": 1
          },
          "properties": {
            "type": "array",
            "optional": true,
            "description": "A list of property names. Events that do not match any of the names will be filtered out.",
            "items": { "$ref": "UpdatePropertyName" },
            "minItems": 1
          },
          "tabId": { "type": "integer", "optional": true },
          "windowId": { "type": "integer", "optional": true },
          "cookieStoreId": { "type": "string", "optional": true }
        }
      }
    ],
    "properties": {
      "TAB_ID_NONE": {
        "value": -1,
        "description": "An ID which represents the absence of a browser tab."
      }
    },
    "functions": [
      {
        "name": "get",
        "type": "function",
        "description": "Retrieves details about the specified tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0
          },
          {
            "type": "function",
            "name": "callback",
            "parameters": [{ "name": "tab", "$ref": "Tab" }]
          }
        ]
      },
      {
        "name": "getCurrent",
        "type": "function",
        "description": "Gets the tab that this script call is being made from. May be undefined if called from a non-tab context (for example: a background page or popup view).",
        "async": "callback",
        "parameters": [
          {
            "type": "function",
            "name": "callback",
            "parameters": [
              {
                "name": "tab",
                "$ref": "Tab",
                "optional": true
              }
            ]
          }
        ]
      },
      {
        "name": "connect",
        "type": "function",
        "description": "Connects to the content script(s) in the specified tab. The $(ref:runtime.onConnect) event is fired in each content script running in the specified tab for the current extension. For more details, see $(topic:messaging)[Content Script Messaging].",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0
          },
          {
            "type": "object",
            "name": "connectInfo",
            "properties": {
              "name": {
                "type": "string",
                "optional": true,
                "description": "Will be passed into onConnect for content scripts that are listening for the connection event."
              },
              "frameId": {
                "type": "integer",
                "optional": true,
                "minimum": 0,
                "description": "Open a port to a specific $(topic:frame_ids)[frame] identified by <code>frameId</code> instead of all frames in the tab."
              }
            },
            "optional": true
          }
        ],
        "returns": {
          "$ref": "runtime.Port",
          "description": "A port that can be used to communicate with the content scripts running in the specified tab. The port's $(ref:runtime.Port) event is fired if the tab closes or does not exist. "
        }
      },
      {
        "name": "sendMessage",
        "type": "function",
        "description": "Sends a single message to the content script(s) in the specified tab, with an optional callback to run when a response is sent back.  The $(ref:runtime.onMessage) event is fired in each content script running in the specified tab for the current extension.",
        "async": "responseCallback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0
          },
          {
            "type": "any",
            "name": "message"
          },
          {
            "type": "object",
            "name": "options",
            "properties": {
              "frameId": {
                "type": "integer",
                "optional": true,
                "minimum": 0,
                "description": "Send a message to a specific $(topic:frame_ids)[frame] identified by <code>frameId</code> instead of all frames in the tab."
              }
            },
            "optional": true
          },
          {
            "type": "function",
            "name": "responseCallback",
            "optional": true,
            "parameters": [
              {
                "name": "response",
                "type": "any",
                "description": "The JSON response object sent by the handler of the message. If an error occurs while connecting to the specified tab, the callback will be called with no arguments and $(ref:runtime.lastError) will be set to the error message."
              }
            ]
          }
        ]
      },
      {
        "name": "create",
        "type": "function",
        "description": "Creates a new tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "object",
            "name": "createProperties",
            "properties": {
              "windowId": {
                "type": "integer",
                "minimum": -2,
                "optional": true,
                "description": "The window to create the new tab in. Defaults to the $(topic:current-window)[current window]."
              },
              "index": {
                "type": "integer",
                "minimum": 0,
                "optional": true,
                "description": "The position the tab should take in the window. The provided value will be clamped to between zero and the number of tabs in the window."
              },
              "url": {
                "type": "string",
                "optional": true,
                "description": "The URL to navigate the tab to initially. Fully-qualified URLs must include a scheme (i.e. 'http://www.google.com', not 'www.google.com'). Relative URLs will be relative to the current page within the extension. Defaults to the New Tab Page."
              },
              "active": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab should become the active tab in the window. Does not affect whether the window is focused (see $(ref:windows.update)). Defaults to <var>true</var>."
              },
              "pinned": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab should be pinned. Defaults to <var>false</var>"
              },
              "openerTabId": {
                "type": "integer",
                "minimum": -1,
                "optional": true,
                "description": "The ID of the tab that opened this tab. If specified, the opener tab must be in the same window as the newly created tab."
              },
              "cookieStoreId": {
                "type": "string",
                "optional": true,
                "description": "The CookieStoreId for the tab that opened this tab."
              },
              "openInReaderMode": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the document in the tab should be opened in reader mode."
              },
              "discarded": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab is marked as 'discarded' when created."
              },
              "title": {
                "type": "string",
                "optional": true,
                "description": "The title used for display if the tab is created in discarded mode."
              },
              "muted": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab should be muted when created."
              }
            }
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": [
              {
                "name": "tab",
                "$ref": "Tab",
                "optional": true,
                "description": "Details about the created tab. Will contain the ID of the new tab."
              }
            ]
          }
        ]
      },
      {
        "name": "duplicate",
        "type": "function",
        "description": "Duplicates a tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "description": "The ID of the tab which is to be duplicated."
          },
          {
            "type": "object",
            "name": "duplicateProperties",
            "optional": true,
            "properties": {
              "index": {
                "type": "integer",
                "optional": true,
                "description": "The position the new tab should take in the window. The provided value will be clamped to between zero and the number of tabs in the window."
              },
              "active": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab should become the active tab in the window. Does not affect whether the window is focused (see $(ref:windows.update)). Defaults to <var>true</var>."
              }
            }
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": [
              {
                "name": "tab",
                "optional": true,
                "description": "Details about the duplicated tab. The $(ref:tabs.Tab) object doesn't contain <code>url</code>, <code>title</code> and <code>favIconUrl</code> if the <code>\"tabs\"</code> permission has not been requested.",
                "$ref": "Tab"
              }
            ]
          }
        ]
      },
      {
        "name": "query",
        "type": "function",
        "description": "Gets all tabs that have the specified properties, or all tabs if no properties are specified.",
        "async": "callback",
        "parameters": [
          {
            "type": "object",
            "name": "queryInfo",
            "properties": {
              "active": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tabs are active in their windows."
              },
              "attention": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tabs are drawing attention."
              },
              "pinned": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tabs are pinned."
              },
              "audible": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tabs are audible."
              },
              "autoDiscardable": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab can be discarded automatically by the browser when resources are low."
              },
              "muted": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tabs are muted."
              },
              "highlighted": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tabs are highlighted.  Works as an alias of active."
              },
              "currentWindow": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tabs are in the $(topic:current-window)[current window]."
              },
              "lastFocusedWindow": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tabs are in the last focused window."
              },
              "status": {
                "$ref": "TabStatus",
                "optional": true,
                "description": "Whether the tabs have completed loading."
              },
              "discarded": {
                "type": "boolean",
                "optional": true,
                "description": "True while the tabs are not loaded with content."
              },
              "hidden": {
                "type": "boolean",
                "optional": true,
                "description": "True while the tabs are hidden."
              },
              "title": {
                "type": "string",
                "optional": true,
                "description": "Match page titles against a pattern."
              },
              "url": {
                "choices": [
                  { "type": "string" },
                  { "type": "array", "items": { "type": "string" } }
                ],
                "optional": true,
                "description": "Match tabs against one or more $(topic:match_patterns)[URL patterns]. Note that fragment identifiers are not matched."
              },
              "windowId": {
                "type": "integer",
                "optional": true,
                "minimum": -2,
                "description": "The ID of the parent window, or $(ref:windows.WINDOW_ID_CURRENT) for the $(topic:current-window)[current window]."
              },
              "windowType": {
                "$ref": "WindowType",
                "optional": true,
                "description": "The type of window the tabs are in."
              },
              "index": {
                "type": "integer",
                "optional": true,
                "minimum": 0,
                "description": "The position of the tabs within their windows."
              },
              "cookieStoreId": {
                "choices": [
                  {
                    "type": "array",
                    "items": { "type": "string" }
                  },
                  {
                    "type": "string"
                  }
                ],
                "optional": true,
                "description": "The CookieStoreId used for the tab."
              },
              "openerTabId": {
                "type": "integer",
                "minimum": -1,
                "optional": true,
                "description": "The ID of the tab that opened this tab. If specified, the opener tab must be in the same window as this tab."
              },
              "groupId": {
                "type": "integer",
                "minimum": -1,
                "optional": true,
                "description": "The ID of the group that the tabs are in, or $(ref:tabGroups.TAB_GROUP_ID_NONE) (-1) for ungrouped tabs."
              },
              "screen": {
                "choices": [
                  {
                    "type": "string",
                    "enum": ["Screen", "Window", "Application"]
                  },
                  { "type": "boolean" }
                ],
                "optional": true,
                "description": "True for any screen sharing, or a string to specify type of screen sharing."
              },
              "camera": {
                "type": "boolean",
                "optional": true,
                "description": "True if the tab is using the camera."
              },
              "microphone": {
                "type": "boolean",
                "optional": true,
                "description": "True if the tab is using the microphone."
              }
            }
          },
          {
            "type": "function",
            "name": "callback",
            "parameters": [
              {
                "name": "result",
                "type": "array",
                "items": {
                  "$ref": "Tab"
                }
              }
            ]
          }
        ]
      },
      {
        "name": "highlight",
        "type": "function",
        "description": "Highlights the given tabs.",
        "async": "callback",
        "parameters": [
          {
            "type": "object",
            "name": "highlightInfo",
            "properties": {
              "windowId": {
                "type": "integer",
                "optional": true,
                "description": "The window that contains the tabs.",
                "minimum": -2
              },
              "populate": {
                "type": "boolean",
                "optional": true,
                "default": true,
                "description": "If true, the $(ref:windows.Window) returned will have a <var>tabs</var> property that contains a list of the $(ref:tabs.Tab) objects. The <code>Tab</code> objects only contain the <code>url</code>, <code>title</code> and <code>favIconUrl</code> properties if the extension's manifest file includes the <code>\"tabs\"</code> permission. If false, the $(ref:windows.Window) won't have the <var>tabs</var> property."
              },
              "tabs": {
                "description": "One or more tab indices to highlight.",
                "choices": [
                  {
                    "type": "array",
                    "items": { "type": "integer", "minimum": 0 }
                  },
                  { "type": "integer" }
                ]
              }
            }
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": [
              {
                "name": "window",
                "$ref": "windows.Window",
                "description": "Contains details about the window whose tabs were highlighted."
              }
            ]
          }
        ]
      },
      {
        "name": "update",
        "type": "function",
        "description": "Modifies the properties of a tab. Properties that are not specified in <var>updateProperties</var> are not modified.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "Defaults to the selected tab of the $(topic:current-window)[current window]."
          },
          {
            "type": "object",
            "name": "updateProperties",
            "properties": {
              "url": {
                "type": "string",
                "optional": true,
                "description": "A URL to navigate the tab to."
              },
              "active": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab should be active. Does not affect whether the window is focused (see $(ref:windows.update))."
              },
              "autoDiscardable": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab can be discarded automatically by the browser when resources are low."
              },
              "highlighted": {
                "type": "boolean",
                "optional": true,
                "description": "Adds or removes the tab from the current selection."
              },
              "pinned": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab should be pinned."
              },
              "muted": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the tab should be muted."
              },
              "openerTabId": {
                "type": "integer",
                "minimum": -1,
                "optional": true,
                "description": "The ID of the tab that opened this tab. If specified, the opener tab must be in the same window as this tab."
              },
              "loadReplace": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the load should replace the current history entry for the tab."
              },
              "successorTabId": {
                "type": "integer",
                "minimum": -1,
                "optional": true,
                "description": "The ID of this tab's successor. If specified, the successor tab must be in the same window as this tab."
              }
            }
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": [
              {
                "name": "tab",
                "$ref": "Tab",
                "optional": true,
                "description": "Details about the updated tab. The $(ref:tabs.Tab) object doesn't contain <code>url</code>, <code>title</code> and <code>favIconUrl</code> if the <code>\"tabs\"</code> permission has not been requested."
              }
            ]
          }
        ]
      },
      {
        "name": "move",
        "type": "function",
        "description": "Moves one or more tabs to a new position within its window, or to a new window. Note that tabs can only be moved to and from normal (window.type === \"normal\") windows.",
        "async": "callback",
        "parameters": [
          {
            "name": "tabIds",
            "description": "The tab or list of tabs to move.",
            "choices": [
              { "type": "integer", "minimum": 0 },
              { "type": "array", "items": { "type": "integer", "minimum": 0 } }
            ]
          },
          {
            "type": "object",
            "name": "moveProperties",
            "properties": {
              "windowId": {
                "type": "integer",
                "minimum": -2,
                "optional": true,
                "description": "Defaults to the window the tab is currently in."
              },
              "index": {
                "type": "integer",
                "minimum": -1,
                "description": "The position to move the window to. -1 will place the tab at the end of the window."
              }
            }
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": [
              {
                "name": "tabs",
                "description": "Details about the moved tabs.",
                "choices": [
                  { "$ref": "Tab" },
                  { "type": "array", "items": { "$ref": "Tab" } }
                ]
              }
            ]
          }
        ]
      },
      {
        "name": "reload",
        "type": "function",
        "description": "Reload a tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The ID of the tab to reload; defaults to the selected tab of the current window."
          },
          {
            "type": "object",
            "name": "reloadProperties",
            "optional": true,
            "properties": {
              "bypassCache": {
                "type": "boolean",
                "optional": true,
                "description": "Whether using any local cache. Default is false."
              }
            }
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": []
          }
        ]
      },
      {
        "name": "warmup",
        "type": "function",
        "description": "Warm up a tab",
        "async": true,
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": false,
            "description": "The ID of the tab to warm up."
          }
        ]
      },
      {
        "name": "remove",
        "type": "function",
        "description": "Closes one or more tabs.",
        "async": "callback",
        "parameters": [
          {
            "name": "tabIds",
            "description": "The tab or list of tabs to close.",
            "choices": [
              { "type": "integer", "minimum": 0 },
              { "type": "array", "items": { "type": "integer", "minimum": 0 } }
            ]
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": []
          }
        ]
      },
      {
        "name": "discard",
        "type": "function",
        "description": "discards one or more tabs.",
        "async": true,
        "parameters": [
          {
            "name": "tabIds",
            "description": "The tab or list of tabs to discard.",
            "choices": [
              { "type": "integer", "minimum": 0 },
              { "type": "array", "items": { "type": "integer", "minimum": 0 } }
            ]
          }
        ]
      },
      {
        "name": "detectLanguage",
        "type": "function",
        "description": "Detects the primary language of the content in a tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "Defaults to the active tab of the $(topic:current-window)[current window]."
          },
          {
            "type": "function",
            "name": "callback",
            "parameters": [
              {
                "type": "string",
                "name": "language",
                "description": "An ISO language code such as <code>en</code> or <code>fr</code>. For a complete list of languages supported by this method, see <a href='http://src.chromium.org/viewvc/chrome/trunk/src/third_party/cld/languages/internal/languages.cc'>kLanguageInfoTable</a>. The 2nd to 4th columns will be checked and the first non-NULL value will be returned except for Simplified Chinese for which zh-CN will be returned. For an unknown language, <code>und</code> will be returned."
              }
            ]
          }
        ]
      },
      {
        "name": "toggleReaderMode",
        "type": "function",
        "description": "Toggles reader mode for the document in the tab.",
        "async": true,
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "Defaults to the active tab of the $(topic:current-window)[current window]."
          }
        ]
      },
      {
        "name": "captureTab",
        "type": "function",
        "description": "Captures an area of a specified tab. You must have $(topic:declare_permissions)[&lt;all_urls&gt;] permission to use this method.",
        "permissions": ["<all_urls>"],
        "async": true,
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The tab to capture. Defaults to the active tab of the current window."
          },
          {
            "$ref": "extensionTypes.ImageDetails",
            "name": "options",
            "optional": true
          }
        ]
      },
      {
        "name": "captureVisibleTab",
        "type": "function",
        "description": "Captures an area of the currently active tab in the specified window. You must have &lt;all_urls&gt; or activeTab permission to use this method.",
        "permissions": ["<all_urls>", "activeTab"],
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "windowId",
            "minimum": -2,
            "optional": true,
            "description": "The target window. Defaults to the $(topic:current-window)[current window]."
          },
          {
            "$ref": "extensionTypes.ImageDetails",
            "name": "options",
            "optional": true
          },
          {
            "type": "function",
            "name": "callback",
            "parameters": [
              {
                "type": "string",
                "name": "dataUrl",
                "description": "A data URL which encodes an image of the visible area of the captured tab. May be assigned to the 'src' property of an HTML Image element for display."
              }
            ]
          }
        ]
      },
      {
        "name": "executeScript",
        "type": "function",
        "max_manifest_version": 2,
        "description": "Injects JavaScript code into a page. For details, see the $(topic:content_scripts)[programmatic injection] section of the content scripts doc.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The ID of the tab in which to run the script; defaults to the active tab of the current window."
          },
          {
            "$ref": "extensionTypes.InjectDetails",
            "name": "details",
            "description": "Details of the script to run."
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "description": "Called after all the JavaScript has been executed.",
            "parameters": [
              {
                "name": "result",
                "optional": true,
                "type": "array",
                "items": { "type": "any" },
                "description": "The result of the script in every injected frame."
              }
            ]
          }
        ]
      },
      {
        "name": "insertCSS",
        "type": "function",
        "max_manifest_version": 2,
        "description": "Injects CSS into a page. For details, see the $(topic:content_scripts)[programmatic injection] section of the content scripts doc.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The ID of the tab in which to insert the CSS; defaults to the active tab of the current window."
          },
          {
            "$ref": "extensionTypes.InjectDetails",
            "name": "details",
            "description": "Details of the CSS text to insert."
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "description": "Called when all the CSS has been inserted.",
            "parameters": []
          }
        ]
      },
      {
        "name": "removeCSS",
        "type": "function",
        "max_manifest_version": 2,
        "description": "Removes injected CSS from a page. For details, see the $(topic:content_scripts)[programmatic injection] section of the content scripts doc.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The ID of the tab from which to remove the injected CSS; defaults to the active tab of the current window."
          },
          {
            "$ref": "extensionTypes.InjectDetails",
            "name": "details",
            "description": "Details of the CSS text to remove."
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "description": "Called when all the CSS has been removed.",
            "parameters": []
          }
        ]
      },
      {
        "name": "setZoom",
        "type": "function",
        "description": "Zooms a specified tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The ID of the tab to zoom; defaults to the active tab of the current window."
          },
          {
            "type": "number",
            "name": "zoomFactor",
            "description": "The new zoom factor. Use a value of 0 here to set the tab to its current default zoom factor. Values greater than zero specify a (possibly non-default) zoom factor for the tab."
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "description": "Called after the zoom factor has been changed.",
            "parameters": []
          }
        ]
      },
      {
        "name": "getZoom",
        "type": "function",
        "description": "Gets the current zoom factor of a specified tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The ID of the tab to get the current zoom factor from; defaults to the active tab of the current window."
          },
          {
            "type": "function",
            "name": "callback",
            "description": "Called with the tab's current zoom factor after it has been fetched.",
            "parameters": [
              {
                "type": "number",
                "name": "zoomFactor",
                "description": "The tab's current zoom factor."
              }
            ]
          }
        ]
      },
      {
        "name": "setZoomSettings",
        "type": "function",
        "description": "Sets the zoom settings for a specified tab, which define how zoom changes are handled. These settings are reset to defaults upon navigating the tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "optional": true,
            "minimum": 0,
            "description": "The ID of the tab to change the zoom settings for; defaults to the active tab of the current window."
          },
          {
            "$ref": "ZoomSettings",
            "name": "zoomSettings",
            "description": "Defines how zoom changes are handled and at what scope."
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "description": "Called after the zoom settings have been changed.",
            "parameters": []
          }
        ]
      },
      {
        "name": "getZoomSettings",
        "type": "function",
        "description": "Gets the current zoom settings of a specified tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "optional": true,
            "minimum": 0,
            "description": "The ID of the tab to get the current zoom settings from; defaults to the active tab of the current window."
          },
          {
            "type": "function",
            "name": "callback",
            "description": "Called with the tab's current zoom settings.",
            "parameters": [
              {
                "$ref": "ZoomSettings",
                "name": "zoomSettings",
                "description": "The tab's current zoom settings."
              }
            ]
          }
        ]
      },
      {
        "name": "print",
        "type": "function",
        "description": "Prints page in active tab.",
        "parameters": []
      },
      {
        "name": "printPreview",
        "type": "function",
        "description": "Shows print preview for page in active tab.",
        "async": "callback",
        "parameters": [
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "description": "Called after print preview entered.",
            "parameters": []
          }
        ]
      },
      {
        "name": "saveAsPDF",
        "type": "function",
        "description": "Saves page in active tab as a PDF file.",
        "async": "callback",
        "parameters": [
          {
            "$ref": "PageSettings",
            "name": "pageSettings",
            "description": "The page settings used to save the PDF file."
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "description": "Called after save as dialog closed.",
            "parameters": [
              {
                "type": "string",
                "name": "status",
                "description": "Save status: saved, replaced, canceled, not_saved, not_replaced."
              }
            ]
          }
        ]
      },
      {
        "name": "show",
        "type": "function",
        "description": "Shows one or more tabs.",
        "permissions": ["tabHide"],
        "async": true,
        "parameters": [
          {
            "name": "tabIds",
            "description": "The TAB ID or list of TAB IDs to show.",
            "choices": [
              { "type": "integer", "minimum": 0 },
              { "type": "array", "items": { "type": "integer", "minimum": 0 } }
            ]
          }
        ]
      },
      {
        "name": "hide",
        "type": "function",
        "description": "Hides one or more tabs. The <code>\"tabHide\"</code> permission is required to hide tabs.  Not all tabs are hidable.  Returns an array of hidden tabs.",
        "permissions": ["tabHide"],
        "async": true,
        "parameters": [
          {
            "name": "tabIds",
            "description": "The TAB ID or list of TAB IDs to hide.",
            "choices": [
              { "type": "integer", "minimum": 0 },
              { "type": "array", "items": { "type": "integer", "minimum": 0 } }
            ]
          }
        ]
      },
      {
        "name": "moveInSuccession",
        "type": "function",
        "async": true,
        "description": "Removes an array of tabs from their lines of succession and prepends or appends them in a chain to another tab.",
        "parameters": [
          {
            "name": "tabIds",
            "type": "array",
            "items": { "type": "integer", "minimum": 0 },
            "minItems": 1,
            "description": "An array of tab IDs to move in the line of succession. For each tab in the array, the tab's current predecessors will have their successor set to the tab's current successor, and each tab will then be set to be the successor of the previous tab in the array. Any tabs not in the same window as the tab indicated by the second argument (or the first tab in the array, if no second argument) will be skipped."
          },
          {
            "name": "tabId",
            "type": "integer",
            "optional": true,
            "default": -1,
            "minimum": -1,
            "description": "The ID of a tab to set as the successor of the last tab in the array, or $(ref:tabs.TAB_ID_NONE) to leave the last tab without a successor. If options.append is true, then this tab is made the predecessor of the first tab in the array instead."
          },
          {
            "name": "options",
            "type": "object",
            "optional": true,
            "properties": {
              "append": {
                "type": "boolean",
                "optional": true,
                "default": false,
                "description": "Whether to move the tabs before (false) or after (true) tabId in the succession. Defaults to false."
              },
              "insert": {
                "type": "boolean",
                "optional": true,
                "default": false,
                "description": "Whether to link up the current predecessors or successor (depending on options.append) of tabId to the other side of the chain after it is prepended or appended. If true, one of the following happens: if options.append is false, the first tab in the array is set as the successor of any current predecessors of tabId; if options.append is true, the current successor of tabId is set as the successor of the last tab in the array. Defaults to false."
              }
            }
          }
        ]
      },
      {
        "name": "goForward",
        "type": "function",
        "description": "Navigate to next page in tab's history, if available",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The ID of the tab to navigate forward."
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": []
          }
        ]
      },
      {
        "name": "goBack",
        "type": "function",
        "description": "Navigate to previous page in tab's history, if available.",
        "async": "callback",
        "parameters": [
          {
            "type": "integer",
            "name": "tabId",
            "minimum": 0,
            "optional": true,
            "description": "The ID of the tab to navigate backward."
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": []
          }
        ]
      },
      {
        "name": "group",
        "type": "function",
        "description": "Adds one or more tabs to a specified group, or if no group is specified, adds the given tabs to a newly created group.",
        "async": "callback",
        "parameters": [
          {
            "name": "options",
            "type": "object",
            "properties": {
              "tabIds": {
                "description": "The tab ID or list of tab IDs to add to the specified group.",
                "choices": [
                  { "type": "integer", "minimum": 0 },
                  {
                    "type": "array",
                    "items": { "type": "integer", "minimum": 0 },
                    "minItems": 1
                  }
                ]
              },
              "groupId": {
                "type": "integer",
                "description": "The ID of the group to add the tabs to. If not specified, a new group will be created.",
                "minimum": 0,
                "optional": true
              },
              "createProperties": {
                "type": "object",
                "optional": true,
                "description": "Configurations for creating a group. Cannot be used if groupId is already specified.",
                "properties": {
                  "windowId": {
                    "type": "integer",
                    "minimum": -2,
                    "optional": true,
                    "description": "The window of the new group. Defaults to the current window."
                  }
                }
              }
            }
          },
          {
            "type": "function",
            "name": "callback",
            "optional": true,
            "parameters": [
              {
                "name": "groupId",
                "type": "integer",
                "minimum": 0,
                "description": "The ID of the group that the tabs were added to."
              }
            ]
          }
        ]
      },
      {
        "name": "ungroup",
        "type": "function",
        "description": "Removes one or more tabs from their respective groups. If any groups become empty, they are deleted.",
        "async": true,
        "parameters": [
          {
            "name": "tabIds",
            "description": "The tab ID or list of tab IDs to remove from their respective groups.",
            "choices": [
              { "type": "integer", "minimum": 0 },
              {
                "type": "array",
                "items": { "type": "integer", "minimum": 0 },
                "minItems": 1
              }
            ]
          }
        ]
      }
    ],
    "events": [
      {
        "name": "onCreated",
        "type": "function",
        "description": "Fired when a tab is created. Note that the tab's URL may not be set at the time this event fired, but you can listen to onUpdated events to be notified when a URL is set.",
        "parameters": [
          {
            "$ref": "Tab",
            "name": "tab",
            "description": "Details of the tab that was created."
          }
        ]
      },
      {
        "name": "onUpdated",
        "type": "function",
        "description": "Fired when a tab is updated.",
        "parameters": [
          { "type": "integer", "name": "tabId", "minimum": 0 },
          {
            "type": "object",
            "name": "changeInfo",
            "description": "Lists the changes to the state of the tab that was updated.",
            "properties": {
              "attention": {
                "type": "boolean",
                "optional": true,
                "description": "The tab's new attention state."
              },
              "audible": {
                "type": "boolean",
                "optional": true,
                "description": "The tab's new audible state."
              },
              "autoDiscardable": {
                "type": "boolean",
                "optional": true,
                "description": "The tab's new autoDiscardable state."
              },
              "discarded": {
                "type": "boolean",
                "optional": true,
                "description": "True while the tab is not loaded with content."
              },
              "favIconUrl": {
                "type": "string",
                "optional": true,
                "permissions": ["tabs"],
                "description": "The tab's new favicon URL. This property is only present if the extension's manifest includes the <code>\"tabs\"</code> permission."
              },
              "groupId": {
                "type": "integer",
                "optional": true,
                "minimum": -1,
                "description": "The tab's new group ID. $(ref:tabGroups.TAB_GROUP_ID_NONE) (-1) if the tab no longer belongs to a tab group."
              },
              "hidden": {
                "type": "boolean",
                "optional": true,
                "description": "The tab's new hidden state."
              },
              "isArticle": {
                "type": "boolean",
                "optional": true,
                "description": "Whether the document in the tab can be rendered in reader mode."
              },
              "mutedInfo": {
                "$ref": "MutedInfo",
                "optional": true,
                "description": "The tab's new muted state and the reason for the change."
              },
              "pinned": {
                "type": "boolean",
                "optional": true,
                "description": "The tab's new pinned state."
              },
              "sharingState": {
                "$ref": "SharingState",
                "optional": true,
                "description": "The tab's new sharing state for screen, microphone and camera."
              },
              "status": {
                "type": "string",
                "optional": true,
                "description": "The status of the tab. Can be either <em>loading</em> or <em>complete</em>."
              },
              "title": {
                "type": "string",
                "optional": true,
                "permissions": ["tabs"],
                "description": "The title of the tab if it has changed. This property is only present if the extension's manifest includes the <code>\"tabs\"</code> permission."
              },
              "url": {
                "type": "string",
                "optional": true,
                "permissions": ["tabs"],
                "description": "The tab's URL if it has changed. This property is only present if the extension's manifest includes the <code>\"tabs\"</code> permission."
              }
            }
          },
          {
            "$ref": "Tab",
            "name": "tab",
            "description": "Gives the state of the tab that was updated."
          }
        ],
        "extraParameters": [
          {
            "$ref": "UpdateFilter",
            "name": "filter",
            "optional": true,
            "description": "A set of filters that restricts the events that will be sent to this listener."
          }
        ]
      },
      {
        "name": "onMoved",
        "type": "function",
        "description": "Fired when a tab is moved within a window. Only one move event is fired, representing the tab the user directly moved. Move events are not fired for the other tabs that must move in response. This event is not fired when a tab is moved between windows. For that, see $(ref:tabs.onDetached).",
        "parameters": [
          { "type": "integer", "name": "tabId", "minimum": 0 },
          {
            "type": "object",
            "name": "moveInfo",
            "properties": {
              "windowId": { "type": "integer", "minimum": 0 },
              "fromIndex": { "type": "integer", "minimum": 0 },
              "toIndex": { "type": "integer", "minimum": 0 }
            }
          }
        ]
      },
      {
        "name": "onActivated",
        "type": "function",
        "description": "Fires when the active tab in a window changes. Note that the tab's URL may not be set at the time this event fired, but you can listen to onUpdated events to be notified when a URL is set.",
        "parameters": [
          {
            "type": "object",
            "name": "activeInfo",
            "properties": {
              "tabId": {
                "type": "integer",
                "minimum": 0,
                "description": "The ID of the tab that has become active."
              },
              "previousTabId": {
                "type": "integer",
                "minimum": 0,
                "optional": true,
                "description": "The ID of the tab that was previously active, if that tab is still open."
              },
              "windowId": {
                "type": "integer",
                "minimum": 0,
                "description": "The ID of the window the active tab changed inside of."
              }
            }
          }
        ]
      },
      {
        "name": "onHighlighted",
        "type": "function",
        "description": "Fired when the highlighted or selected tabs in a window changes.",
        "parameters": [
          {
            "type": "object",
            "name": "highlightInfo",
            "properties": {
              "windowId": {
                "type": "integer",
                "minimum": 0,
                "description": "The window whose tabs changed."
              },
              "tabIds": {
                "type": "array",
                "items": { "type": "integer", "minimum": 0 },
                "description": "All highlighted tabs in the window."
              }
            }
          }
        ]
      },
      {
        "name": "onDetached",
        "type": "function",
        "description": "Fired when a tab is detached from a window, for example because it is being moved between windows.",
        "parameters": [
          { "type": "integer", "name": "tabId", "minimum": 0 },
          {
            "type": "object",
            "name": "detachInfo",
            "properties": {
              "oldWindowId": { "type": "integer", "minimum": 0 },
              "oldPosition": { "type": "integer", "minimum": 0 }
            }
          }
        ]
      },
      {
        "name": "onAttached",
        "type": "function",
        "description": "Fired when a tab is attached to a window, for example because it was moved between windows.",
        "parameters": [
          { "type": "integer", "name": "tabId", "minimum": 0 },
          {
            "type": "object",
            "name": "attachInfo",
            "properties": {
              "newWindowId": { "type": "integer", "minimum": 0 },
              "newPosition": { "type": "integer", "minimum": 0 }
            }
          }
        ]
      },
      {
        "name": "onRemoved",
        "type": "function",
        "description": "Fired when a tab is closed.",
        "parameters": [
          { "type": "integer", "name": "tabId", "minimum": 0 },
          {
            "type": "object",
            "name": "removeInfo",
            "properties": {
              "windowId": {
                "type": "integer",
                "minimum": 0,
                "description": "The window whose tab is closed."
              },
              "isWindowClosing": {
                "type": "boolean",
                "description": "True when the tab is being closed because its window is being closed."
              }
            }
          }
        ]
      },
      {
        "name": "onReplaced",
        "type": "function",
        "description": "Fired when a tab is replaced with another tab due to prerendering or instant.",
        "parameters": [
          { "type": "integer", "name": "addedTabId", "minimum": 0 },
          { "type": "integer", "name": "removedTabId", "minimum": 0 }
        ]
      },
      {
        "name": "onZoomChange",
        "type": "function",
        "description": "Fired when a tab is zoomed.",
        "parameters": [
          {
            "type": "object",
            "name": "ZoomChangeInfo",
            "properties": {
              "tabId": { "type": "integer", "minimum": 0 },
              "oldZoomFactor": { "type": "number" },
              "newZoomFactor": { "type": "number" },
              "zoomSettings": { "$ref": "ZoomSettings" }
            }
          }
        ]
      }
    ]
  }
]
PK